/******************************************************************************
 *
 *                Copyright (c) 2017-2019 by Löwenware Ltd
 *             Please, refer LICENSE file for legal information
 *
 ******************************************************************************/

/**
 * @file context.h
 * @author Ilja Kartašov <ik@lowenware.com>
 * @brief 
 *
 * @see https://lowenware.com/aisl/
 */

#ifndef CONTEXT_H_683B0A86_2A15_483D_B0F9_7BFBB4BA068F
#define CONTEXT_H_683B0A86_2A15_483D_B0F9_7BFBB4BA068F

#define AX_CONTEXT(x) ((AxContext)x)

#include <mods/module.h>

/** @brief Root level ASIL mod's context structure
 */
struct ax_context {
	AxModule mod; /**< Mod's pointer */
};

/** @brief Root level ASIL mod's context structure pointer
 */
typedef struct ax_context * AxContext;


/** @brief Allocates zeroed #aislx_t context
 *  @param mod an instance of #aislx_t
 *  @return pointer to newly allocated #aisl_mox_ctx_t
 */
AxContext
ax_context_new(AxModule mod);


/** @brief Frees previosly allocated #aislx_ctx_t
 *  @param ctx an instance of mod's context structure
 *  */
void
ax_context_free(AxContext ctx);

#endif /* !AISLX_CTX_H */
